%define gcj_support         1
%define eclipse_base        %{_datadir}/eclipse

Name: eclipse-mylar 
Summary: Mylar is a task-focused UI for Eclipse
Version: 2.0
Release: 0.1.M2a.1%{?dist} 
License: Eclipse Public License
URL: http://www.eclipse.org/mylar

# mkdir temp && cd temp
# sh fetch-mylar.sh
# tar cjf org.eclipse.mylar-R_2_0_M2a_e_3_2-fetched-src.tar.bz2 org.eclipse.mylar
Source0: org.eclipse.mylar-R_2_0_M2a_e_3_2-fetched-src.tar.bz2
Source1: fetch-mylar.sh

# SSLSocketFactory#createSocket() is not implemented in GNU Classpath
# http://gcc.gnu.org/bugzilla/show_bug.cgi?id=31626
Patch3: %{name}-createSocketworkaround.patch

BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if %{gcj_support}
BuildRequires:    gcc-java
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%else
BuildRequires:    java-devel >= 1.5.0
%endif

%if ! %{gcj_support}
BuildArch: noarch
%endif

BuildRequires: eclipse-pde >= 3.2.1
BuildRequires: eclipse-platform >= 3.2.1
BuildRequires: jakarta-commons-codec
BuildRequires: jakarta-commons-httpclient
BuildRequires: jakarta-commons-logging
BuildRequires: ws-commons-util
BuildRequires: xmlrpc3-client
BuildRequires: xmlrpc3-common
Requires: eclipse-platform >= 3.2.1
Requires: jakarta-commons-codec
Requires: jakarta-commons-httpclient
Requires: jakarta-commons-logging
Requires: ws-commons-util
Requires: xmlrpc3-client
Requires: xmlrpc3-common

Group: Development/Tools

%description
Mylar integrates task support into Eclipse.  It supports offline editing
for certain task repositories and monitors work activity to hide
information that is not relevant to the current task.

#Provides:  org.eclipse.mylar.doc = 1.0.0.v20061219-1530
#Provides:  org.eclipse.mylar = 1.0.0.v20061219-1530
#Provides:  org.eclipse.mylar.context.core = 1.0.0.v20061219-1530
#Provides:  org.eclipse.mylar.tasks.ui = 1.0.0.v20061219-1530
#Provides:  org.eclipse.mylar.monitor = 1.0.0.v20061219-1530
#Provides:  org.eclipse.mylar.tasks.core = 1.0.0.v20061219-1530
#Provides:  org.eclipse.mylar.tasks.web = 1.0.0.v20061219-1530
#Requires:  org.eclipse.ui >= 3.3.0
#Requires:  org.eclipse.ui.forms
#Requires:  org.eclipse.core.runtime
#Requires:  org.eclipse.jface.text
#Requires:  org.eclipse.update.core
#Requires:  org.eclipse.ui.browser
#Requires:  org.eclipse.ui.editors
#Requires:  org.eclipse.ui.views
#Requires:  org.eclipse.ui.workbench.texteditor
#Requires:  org.eclipse.core.resources
#Requires:  org.eclipse.ui.ide
#Requires:  org.eclipse.mylar.tasks.ui
#Requires:  org.eclipse.mylar.context.core
#Requires:  org.eclipse.mylar.tasks.core
#Requires:  org.eclipse.mylar.monitor
#Requires:  org.eclipse.search

%package  bugzilla
Summary:  Mylar Bugzilla Connector
Requires: %{name} = %{version}-%{release}
Group: Development/Tools
Obsoletes: eclipse-bugzilla
Provides: eclipse-bugzilla

%description bugzilla
Bugzilla client integrated with Eclipse and Mylar; can be used
standalone.

#Provides:  org.eclipse.mylar.bugzilla.core = 1.0.0.v20061219-1530
#Provides:  org.eclipse.mylar.bugzilla.ui = 1.0.0.v20061219-1530
#Requires:  org.eclipse.core.runtime
#Requires:  org.eclipse.mylar.context.core >= 1.0.0
#Requires:  org.eclipse.mylar.tasks.core
#Requires:  org.eclipse.ui
#Requires:  org.eclipse.core.resources
#Requires:  org.eclipse.compare
#Requires:  org.eclipse.search
#Requires:  org.eclipse.ui.views
#Requires:  org.eclipse.ui.ide
#Requires:  org.eclipse.ui.forms
#Requires:  org.eclipse.jface.text
#Requires:  org.eclipse.team.ui
#Requires:  org.eclipse.team.cvs.ui
#Requires:  org.eclipse.ui.editors
#Requires:  org.eclipse.ui.workbench.texteditor
#Requires:  org.eclipse.update.ui
#Requires:  org.eclipse.mylar.tasks.ui
#Requires:  org.eclipse.mylar_feature >= 1.0.0
#Requires:  org.eclipse.mylar.bugzilla.core

%package  ide
Summary:  Mylar Focused UI
Requires: %{name} = %{version}-%{release}
Group: Development/Tools

%description ide
Mylar Focused UI for reducing information overload when working with
tasks. Filters and decorates views and editors to focus on the task
context.

#Provides:  org.eclipse.mylar.java = 1.0.0.v20061219-1530
#Provides:  org.eclipse.mylar.ide = 1.0.0.v20061219-1530
#Provides:  org.eclipse.mylar.resources = 1.0.0.v20061219-1530
#Provides:  org.eclipse.mylar.context.ui = 1.0.0.v20061219-1530
#Provides:  org.eclipse.mylar.team = 1.0.0.v20061219-1530
#Requires:  org.eclipse.ui
#Requires:  org.eclipse.core.runtime
#Requires:  org.eclipse.core.resources
#Requires:  org.eclipse.jdt
#Requires:  org.eclipse.jdt.core
#Requires:  org.eclipse.ui.editors
#Requires:  org.eclipse.jface.text
#Requires:  org.eclipse.ui.workbench.texteditor
#Requires:  org.eclipse.search
#Requires:  org.eclipse.ui.views
#Requires:  org.eclipse.jdt.debug.ui
#Requires:  org.eclipse.jdt.ui
#Requires:  org.eclipse.team.cvs.ui
#Requires:  org.eclipse.debug.ui
#Requires:  org.eclipse.jdt.junit
#Requires:  org.eclipse.jdt.junit.runtime
#Requires:  org.eclipse.pde.junit.runtime
#Requires:  org.eclipse.jdt.launching
#Requires:  org.eclipse.debug.core
#Requires:  org.eclipse.pde.ui
#Requires:  org.eclipse.pde.core
#Requires:  org.eclipse.ui.ide
#Requires:  org.eclipse.mylar.context.core >= 1.0.0
#Requires:  org.eclipse.mylar.ide
#Requires:  org.eclipse.mylar.tasks.ui
#Requires:  org.eclipse.mylar.context.ui
#Requires:  org.eclipse.team.ui
#Requires:  org.eclipse.team.cvs.core
#Requires:  org.eclipse.team.core
#Requires:  org.eclipse.ui.forms
#Requires:  org.eclipse.mylar.monitor
#Requires:  org.eclipse.mylar.resources
#Requires:  org.eclipse.jdt.debug
#Requires:  org.eclipse.ui.navigator
#Requires:  org.eclipse.ant.ui
#Requires:  org.eclipse.ui.navigator.resources
#Requires:  org.eclipse.pde.runtime
#Requires:  org.eclipse.compare
#Requires:  org.eclipse.mylar.tasks.core
#Requires:  org.eclipse.jface
#Requires:  org.eclipse.ui.workbench
#Requires:  org.eclipse.mylar_feature >= 1.0.0
#Requires:  org.eclipse.mylar.doc

%package  trac
Summary:  Mylar Trac Connector
Requires: %{name} = %{version}-%{release}
Group: Development/Tools

%description trac
Trac client integrated with Eclipse and Mylar; can be used standalone.

#Provides:  org.eclipse.mylar.trac.ui = 1.0.0.v20061219-1530
#Provides:  org.eclipse.mylar.trac.core = 1.0.0.v20061219-1530
#Requires:  org.eclipse.ui
#Requires:  org.eclipse.core.runtime
#Requires:  org.eclipse.mylar.context.core >= 1.0.0
#Requires:  org.eclipse.mylar.tasks.ui
#Requires:  org.eclipse.mylar.tasks.core
#Requires:  org.eclipse.mylar_feature >= 1.0.0
#Requires:  org.eclipse.ui.forms
#Requires:  org.eclipse.search
#Requires:  org.eclipse.mylar.trac.core

%prep
%setup -q -n org.eclipse.mylar
pushd org.eclipse.mylar
%patch3 -p0
popd
/bin/sh -x %{eclipse_base}/buildscripts/copy-platform SDK %{eclipse_base}
mkdir home

# symlink out to jars we built
pushd org.eclipse.mylar/lib-httpclient
rm commons-*.jar
ln -s %{_javadir}/commons-codec-1.3.jar
ln -s %{_javadir}/commons-httpclient.jar commons-httpclient-3.0.1.jar
ln -s %{_javadir}/commons-logging-api.jar
ln -s %{_javadir}/commons-logging.jar
popd
pushd org.eclipse.mylar/lib-xmlrpc
rm ws-commons-*.jar
rm xmlrpc*.jar
ln -s %{_javadir}/xmlrpc3-client-3.0.jar xmlrpc-client-3.0.jar
ln -s %{_javadir}/xmlrpc3-common-3.0.jar xmlrpc-common-3.0.jar
ln -s %{_javadir}/ws-commons-util-1.0.1.jar
popd

%build
SDK=$(cd SDK > /dev/null && pwd)

# Eclipse may try to write to the home directory.
homedir=$(cd home > /dev/null && pwd)

# build the main mylar feature
eclipse \
     -nosplash                                         \
     -application org.eclipse.ant.core.antRunner       \
     -Dtype=feature                                    \
     -Did=org.eclipse.mylar_feature                    \
     -DbaseLocation=$SDK                               \
     -DsourceDirectory=$(pwd)                          \
     -DbuildDirectory=$(pwd)/build                     \
     -Dbuilder=%{eclipse_base}/plugins/org.eclipse.pde.build/templates/package-build \
     -f %{eclipse_base}/plugins/org.eclipse.pde.build/scripts/build.xml \
     -vmargs -Duser.home=$homedir \
     -DJ2SE-1.5=%{_jvmdir}/java/jre/lib/rt.jar

# build the mylar bugzilla feature
eclipse \
     -nosplash                                         \
     -application org.eclipse.ant.core.antRunner       \
     -Dtype=feature                                    \
     -Did=org.eclipse.mylar.bugzilla_feature           \
     -DbaseLocation=$SDK                               \
     -DsourceDirectory=$(pwd)                          \
     -DbuildDirectory=$(pwd)/build                     \
     -Dbuilder=%{eclipse_base}/plugins/org.eclipse.pde.build/templates/package-build \
     -f %{eclipse_base}/plugins/org.eclipse.pde.build/scripts/build.xml \
     -vmargs -Duser.home=$homedir \
     -DJ2SE-1.5=%{_jvmdir}/java/jre/lib/rt.jar

# build the mylar ide feature
eclipse \
     -nosplash                                         \
     -application org.eclipse.ant.core.antRunner       \
     -Dtype=feature                                    \
     -Did=org.eclipse.mylar.ide_feature                \
     -DbaseLocation=$SDK                               \
     -DsourceDirectory=$(pwd)                          \
     -DbuildDirectory=$(pwd)/build                     \
     -Dbuilder=%{eclipse_base}/plugins/org.eclipse.pde.build/templates/package-build \
     -f %{eclipse_base}/plugins/org.eclipse.pde.build/scripts/build.xml \
     -vmargs -Duser.home=$homedir \
     -DJ2SE-1.5=%{_jvmdir}/java/jre/lib/rt.jar

# build the mylar trac feature
eclipse \
     -nosplash                                         \
     -application org.eclipse.ant.core.antRunner       \
     -Dtype=feature                                    \
     -Did=org.eclipse.mylar.trac_feature               \
     -DbaseLocation=$SDK                               \
     -DsourceDirectory=$(pwd)                          \
     -DbuildDirectory=$(pwd)/build                     \
     -Dbuilder=%{eclipse_base}/plugins/org.eclipse.pde.build/templates/package-build \
     -f %{eclipse_base}/plugins/org.eclipse.pde.build/scripts/build.xml \
     -vmargs -Duser.home=$homedir \
     -DJ2SE-1.5=%{_jvmdir}/java/jre/lib/rt.jar

%install
rm -rf %{buildroot}
install -d -m 755 $RPM_BUILD_ROOT%{eclipse_base}
unzip -q -d $RPM_BUILD_ROOT%{eclipse_base}/.. \
 build/rpmBuild/org.eclipse.mylar_feature.zip
unzip -q -d $RPM_BUILD_ROOT%{eclipse_base}/.. \
 build/rpmBuild/org.eclipse.mylar.bugzilla_feature.zip
unzip -q -d $RPM_BUILD_ROOT%{eclipse_base}/.. \
 build/rpmBuild/org.eclipse.mylar.ide_feature.zip
unzip -q -d $RPM_BUILD_ROOT%{eclipse_base}/.. \
 build/rpmBuild/org.eclipse.mylar.trac_feature.zip

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf %{buildroot}

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi

%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files bugzilla
%defattr(-,root,root,-)
%{eclipse_base}/plugins/org.eclipse.mylar.bugzilla.core_*.jar
%{eclipse_base}/plugins/org.eclipse.mylar.bugzilla.ui_*.jar
%dir %{eclipse_base}/features/org.eclipse.mylar.bugzilla_feature_*
%doc %{eclipse_base}/features/org.eclipse.mylar.bugzilla_feature_*/license.html
%doc %{eclipse_base}/features/org.eclipse.mylar.bugzilla_feature_*/about.html
%doc %{eclipse_base}/features/org.eclipse.mylar.bugzilla_feature_*/epl-v10.html
%{eclipse_base}/features/org.eclipse.mylar.bugzilla_feature_*/feature.xml
%if %{gcj_support}
%{_libdir}/gcj/%{name}/org.eclipse.mylar.bugzilla*
%endif

%files ide
%defattr(-,root,root,-)
%{eclipse_base}/plugins/org.eclipse.mylar.team_*.jar
%{eclipse_base}/plugins/org.eclipse.mylar.context.ui_*.jar
%{eclipse_base}/plugins/org.eclipse.mylar.java_*.jar
%{eclipse_base}/plugins/org.eclipse.mylar.resources_*.jar
%{eclipse_base}/plugins/org.eclipse.mylar.ide_*.jar
%dir %{eclipse_base}/features/org.eclipse.mylar.ide_feature_*
%doc %{eclipse_base}/features/org.eclipse.mylar.ide_feature_*/license.html
%doc %{eclipse_base}/features/org.eclipse.mylar.ide_feature_*/epl-v10.html
%{eclipse_base}/features/org.eclipse.mylar.ide_feature_*/feature.xml
%if %{gcj_support}
%{_libdir}/gcj/%{name}/org.eclipse.mylar.team_*
%{_libdir}/gcj/%{name}/org.eclipse.mylar.context.ui_*
%{_libdir}/gcj/%{name}/org.eclipse.mylar.java_*
%{_libdir}/gcj/%{name}/org.eclipse.mylar.resources_*
%{_libdir}/gcj/%{name}/org.eclipse.mylar.ide_*
%endif

%files trac
%defattr(-,root,root,-)
%{eclipse_base}/plugins/org.eclipse.mylar.trac.core_*.jar
%{eclipse_base}/plugins/org.eclipse.mylar.trac.ui_*.jar
%dir %{eclipse_base}/features/org.eclipse.mylar.trac_feature_*
%{eclipse_base}/features/org.eclipse.mylar.trac_feature_*/feature.xml
%if %{gcj_support}
%{_libdir}/gcj/%{name}/org.eclipse.mylar.trac*
%endif

%files
%defattr(-,root,root,-)
%{eclipse_base}/plugins/org.eclipse.mylar.tasks.web_*.jar
%{eclipse_base}/plugins/org.eclipse.mylar.context.core_*.jar
%{eclipse_base}/plugins/org.eclipse.mylar.tasks.ui_*.jar
%{eclipse_base}/plugins/org.eclipse.mylar.tasks.core_*.jar
%{eclipse_base}/plugins/org.eclipse.mylar_*.jar
%{eclipse_base}/plugins/org.eclipse.mylar.monitor.core_*.jar
%{eclipse_base}/plugins/org.eclipse.mylar.monitor.ui_*.jar
%{eclipse_base}/plugins/org.eclipse.mylar.doc_*.jar
%doc %{eclipse_base}/features/org.eclipse.mylar_feature_*/license.html
%doc %{eclipse_base}/features/org.eclipse.mylar_feature_*/epl-v10.html
%{eclipse_base}/features/org.eclipse.mylar_feature_*/feature.xml
%if %{gcj_support}
%{_libdir}/gcj/%{name}/org.eclipse.mylar.tasks.web_*
%{_libdir}/gcj/%{name}/org.eclipse.mylar.context.core_*
%{_libdir}/gcj/%{name}/org.eclipse.mylar.tasks.ui_*
%{_libdir}/gcj/%{name}/org.eclipse.mylar.tasks.core_*
%{_libdir}/gcj/%{name}/org.eclipse.mylar_*
%{_libdir}/gcj/%{name}/org.eclipse.mylar.monitor.core_*
%{_libdir}/gcj/%{name}/org.eclipse.mylar.monitor.ui_*
%{_libdir}/gcj/%{name}/org.eclipse.mylar.doc_*
%dir %{_libdir}/gcj/%{name}
%endif

%changelog
* Wed Apr 25 2007 Andrew Overholt <overholt@redhat.com> 2.0-0.1.M2a.1
- 2.0M2a (a re-tag to fix some tagging issues).

* Wed Apr 18 2007 Andrew Overholt <overholt@redhat.com> 1.0-4
- Add workaround for missing method in GNU Classpath.

* Thu Apr 12 2007 Andrew Overholt <overholt@redhat.com> 1.0-3
- Add Obsoletes and Provides for eclipse-bugzilla on
  eclipse-mylar-bugzilla (comments in bug #222677).  If someone notices
  missing functionality to warrant removing the Provides, please file a
  bug.

* Tue Mar 20 2007 Andrew Overholt <overholt@redhat.com> 1.0-2
- Use xmlrpc3 jars instead of xmlrpc

* Fri Mar 16 2007 Andrew Overholt <overholt@redhat.com> 1.0-1
- Initial build
